                    (* +----------------------+
                       |  Tests de primalit  |
                       +----------------------+ *)

(* mthode mave *)
let premier_naf n =
  let n = abs(n) in
  if n < 2 then false
  else begin
    let i = ref(2) and res = ref(true) in
    while !i * !i <= n & !res do
      res := n mod !i > 0;
      i := !i + 1
    done;
    !res
  end
;;

premier_naf 1001;;
premier_naf 1009;;


(* vite les nombres divisibles par 2,3,5 *)
let premier_5 n =
  let n = abs(n) in
  if n < 2            then false
  else if n = 2       then true
  else if n mod 2 = 0 then false
  else if n = 3       then true
  else if n mod 3 = 0 then false
  else if n = 5       then true
  else if n mod 5 = 0 then false
  else begin
    let res = ref(true) and encore = ref(true) in
    let test(x) = encore := !encore & x*x <= n;
                  if !encore then res := !res & n mod x > 0
    in
    let k = ref(0) in
    while !encore do
      test(!k*30+7);
      test(!k*30+11);
      test(!k*30+13);
      k := !k+1;
      test(!k*30-13);
      test(!k*30-11);
      test(!k*30-7);
      test(!k*30-1);
      test(!k*30+1);
    done;
    !res
  end
;;

premier_5 1001;;
premier_5 1009;;

(* test de fermat *)
let rec puiss_mod x a n =
  if n < 1 then 1
  else let y = puiss_mod x a (n/2) in
       let z = y*y mod a           in
       if n mod 2 = 0 then z else z*x mod a
;;

let fermat n =
  let n = abs(n) in
  if      n = 2 then true
  else if n = 3 then true
  else if n = 5 then true
  else if n < 5 then false
  else begin
    let res = ref(true) and i=ref(5) in
    while !res & !i > 0 do
      let x = random__int ((n-1)/2-2) in
      res := puiss_mod x n (n-1) = 1;
      i := !i-1
    done;
    !res
  end
;;

fermat 1001;;
fermat 1009;;
fermat 561;;

(* test de Rabin-Miller *)
let rec dcompose n =
  if n mod 2 = 1 then (n,0) else let (a,b) = dcompose(n/2) in (a,b+1)
;;

let test_rm x n a b =
  let y = ref(puiss_mod x n a) and i = ref(0) in
  if !y  = 1 then true
  else begin
    while !i < b & !y <> 1 & !y <> n-1 do
      y := !y * !y mod n;
      i := !i + 1
    done;
    !i < b & !y <> 1
  end
;;
  

let rabin_miller n =
  let n = abs(n) in
  if      n = 2 then true
  else if n = 3 then true
  else if n = 5 then true
  else if n < 5 then false
  else begin
    let (a,b) = dcompose(n-1) in
    let res = ref(true) and i=ref(5) in
    while !res & !i > 0 do
      let x = random__int ((n-1)/2-2) in
      res := test_rm x n a b;
      i := !i-1
    done;
    !res
  end
;;

rabin_miller 1001;;
rabin_miller 1009;;
rabin_miller 561;;
